/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-fuerte-ros-comm-1.8.16-1precise-20130502-1635/test/perf_roscpp/msg/LatencyMessage.msg
 *
 */


#ifndef PERF_ROSCPP_MESSAGE_LATENCYMESSAGE_H
#define PERF_ROSCPP_MESSAGE_LATENCYMESSAGE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace perf_roscpp
{
template <class ContainerAllocator>
struct LatencyMessage_
{
  typedef LatencyMessage_<ContainerAllocator> Type;

  LatencyMessage_()
    : publish_time(0.0)
    , receipt_time(0.0)
    , count(0)
    , thread_index(0)
    , array()  {
    }
  LatencyMessage_(const ContainerAllocator& _alloc)
    : publish_time(0.0)
    , receipt_time(0.0)
    , count(0)
    , thread_index(0)
    , array(_alloc)  {
    }



   typedef double _publish_time_type;
  _publish_time_type publish_time;

   typedef double _receipt_time_type;
  _receipt_time_type receipt_time;

   typedef uint64_t _count_type;
  _count_type count;

   typedef uint32_t _thread_index_type;
  _thread_index_type thread_index;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _array_type;
  _array_type array;




  typedef boost::shared_ptr< ::perf_roscpp::LatencyMessage_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::perf_roscpp::LatencyMessage_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct LatencyMessage_

typedef ::perf_roscpp::LatencyMessage_<std::allocator<void> > LatencyMessage;

typedef boost::shared_ptr< ::perf_roscpp::LatencyMessage > LatencyMessagePtr;
typedef boost::shared_ptr< ::perf_roscpp::LatencyMessage const> LatencyMessageConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::perf_roscpp::LatencyMessage_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace perf_roscpp

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'perf_roscpp': ['/tmp/buildd/ros-fuerte-ros-comm-1.8.16-1precise-20130502-1635/test/perf_roscpp/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::perf_roscpp::LatencyMessage_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::perf_roscpp::LatencyMessage_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::perf_roscpp::LatencyMessage_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
{
  static const char* value()
  {
    return "be90d117303321f392404ed7edeb7c8c";
  }

  static const char* value(const ::perf_roscpp::LatencyMessage_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xbe90d117303321f3ULL;
  static const uint64_t static_value2 = 0x92404ed7edeb7c8cULL;
};

template<class ContainerAllocator>
struct DataType< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
{
  static const char* value()
  {
    return "perf_roscpp/LatencyMessage";
  }

  static const char* value(const ::perf_roscpp::LatencyMessage_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 publish_time\n\
float64 receipt_time\n\
uint64 count\n\
uint32 thread_index\n\
uint8[] array\n\
\n\
\n\
";
  }

  static const char* value(const ::perf_roscpp::LatencyMessage_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.publish_time);
      stream.next(m.receipt_time);
      stream.next(m.count);
      stream.next(m.thread_index);
      stream.next(m.array);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct LatencyMessage_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::perf_roscpp::LatencyMessage_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::perf_roscpp::LatencyMessage_<ContainerAllocator>& v)
  {
    s << indent << "publish_time: ";
    Printer<double>::stream(s, indent + "  ", v.publish_time);
    s << indent << "receipt_time: ";
    Printer<double>::stream(s, indent + "  ", v.receipt_time);
    s << indent << "count: ";
    Printer<uint64_t>::stream(s, indent + "  ", v.count);
    s << indent << "thread_index: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.thread_index);
    s << indent << "array[]" << std::endl;
    for (size_t i = 0; i < v.array.size(); ++i)
    {
      s << indent << "  array[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.array[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // PERF_ROSCPP_MESSAGE_LATENCYMESSAGE_H
