# Remove duplicate libraries, generalized from PCLConfig.cmake.in
macro(remove_duplicate_libraries _unfiltered_libraries _final_filtered_libraries)
  set(_filtered_libraries)
  set(_debug_libraries)
  set(_optimized_libraries)
  set(_other_libraries)
  set(_waiting_for_debug 0)
  set(_waiting_for_optimized 0)
  set(_library_position -1)
  foreach(library ${${_unfiltered_libraries}})
    if("${library}" STREQUAL "debug")
      set(_waiting_for_debug 1)
    elseif("${library}" STREQUAL "optimized")
      set(_waiting_for_optimized 1)
    elseif(_waiting_for_debug)
      list(FIND _debug_libraries "${library}" library_position)
      if(library_position EQUAL -1)
        list(APPEND ${_filtered_libraries} debug ${library})
        list(APPEND _debug_libraries ${library})
      endif()
      set(_waiting_for_debug 0)
    elseif(_waiting_for_optimized)
      list(FIND _optimized_libraries "${library}" library_position)
      if(library_position EQUAL -1)
        list(APPEND ${_filtered_libraries} optimized ${library})
        list(APPEND _optimized_libraries ${library})
      endif()
      set(_waiting_for_optimized 0)
    else("${library}" STREQUAL "debug")
      list(FIND _other_libraries "${library}" library_position)
      if(library_position EQUAL -1)
        list(APPEND ${_filtered_libraries} ${library})
        list(APPEND _other_libraries ${library})
      endif()
    endif("${library}" STREQUAL "debug")
  endforeach(library)
  set(_final_filtered_libraries _filtered_libraries)
endmacro(remove_duplicate_libraries)


if (rostest_CONFIG_INCLUDED)
  return()
endif()
set(rostest_CONFIG_INCLUDED TRUE)

if (NOT "Xinclude" STREQUAL "X")
  set(rostest_INCLUDE_DIRS /opt/ros/fuerte/include) #TODO FIX this.
endif()

foreach(lib )
  set(onelib "${lib}-NOTFOUND")
  find_library(onelib ${lib}
    PATHS /opt/ros/fuerte/lib
    NO_DEFAULT_PATH
    )
  if(NOT onelib)
    message(FATAL_ERROR "Library '${lib}' in package rostest is not installed properly")
  endif()
  list(APPEND rostest_LIBRARIES ${onelib})
endforeach()

foreach(dep )
  if(NOT ${dep}_FOUND)
    find_package(${dep})
  endif()
  list(APPEND rostest_INCLUDE_DIRS ${${dep}_INCLUDE_DIRS})
  list(APPEND rostest_LIBRARIES ${${dep}_LIBRARIES})
endforeach()

if (rostest_INCLUDE_DIRS)
  list(REMOVE_DUPLICATES rostest_INCLUDE_DIRS)
endif()
if(rostest_LIBRARIES)
  remove_duplicate_libraries(rostest_LIBRARIES rostest_LIBRARIES)
endif()

foreach(extra rostest-extras.cmake)
  include(/opt/ros/fuerte/share/rostest/cmake/${extra})
endforeach()
